$extend(OS.ext, {
    'IdleUpdate': new Class({
        'options': {
            'delay': 1000,
            'onIdleChange': Class.empty
        },
        
        'initialize':function(el, options) {
            this.setOptions(options);
            this.el = $(el);
            this.element = this.el;
            this.oldValue = this.el.value;
            this.el.addEvent('change', this.onchange.bind(this));
            this.el.addEvent('keyup', this.onchange.bind(this));
        },
        
        'onchange': function() {
            if (this.delay != null) {
                $clear(this.delay);
                this.delay = null;
            };
            
            this.delay = this.fire.delay(this.options.delay, this);
        },
        
        'fire': function() {
            if (this.el.value != this.oldValue) {
                this.fireEvent('onIdleChange', this.el);
                this.oldValue = this.el.value;
            }
        }
    })
});