<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.4
        Web Desktop System
*/
/**********************************************
 * File: ProtocolBuffers.class.php
 * Class: ProtocolBuffers
 **********************************************/
class ProtocolBuffers
{
/**********************************************
 * Properties: Properties
 * user - username
 **********************************************/
    private $user;

/**********************************************
 * Constructor: __construct
 *
 * Parameters:
 *  os - os object
  **********************************************/
    function __construct($os)
    {
        $this->user = $os->user;
        $this->path = $os->path;
    }

/**********************************************
 * Method: pb_compile
 * Proto Buffers compile class
 **********************************************/
	protected function pb_compile($file)
	{	
        require_once($this->path.'/Kernel/Ext/pb4php/parser/pb_parser.php');
        $pb = new PBParser();
        if($pb->parse($this->path.'/Kernel/Server/ProtocolBuffers/'.$file.'.proto', 'Kernel/Server/ProtocolBuffers/'))
        {
            return 'pb_compile: Prototype compiled successfully !';
        }
        else
        {
            return 'pb_compile: Error on prototype compilation !';
        }
	}

/**********************************************
 * Method: pb_require
 * Proto Buffers requirement
 **********************************************/
	protected function pb_require($file)
	{
        $compile = '';
        $class = $this->path.'/Kernel/Server/ProtocolBuffers/pb_proto_'.$file.'.php';
        if(!is_file($class))
        {
            $compile = $this->pb_compile($file);
        }
        require_once($this->path.'/Kernel/Ext/pb4php/message/pb_message.php');
        require_once($class);
        return $compile;
	}

/**********************************************
 * Method: pb_set
 * Proto Buffers set
 *
 * Parameters:
 *   o - PB Object
 *   file - File to store the object
 **********************************************/
	public function pb_set($o, $file)
	{
        $data = $this->path.'/fs/'.$this->user.'/Data/'.basename($file);
        if(is_file($data))
        {
            $string = $o->SerializeToString();
            return @file_put_contents($data, $string) ? true : "pb_set: '$file': Permission denied";
        }
        else
        {
            return "pb_set: '$file' does not exist";
        }
	}
	
/**********************************************
 * Method: pb_get
 * Proto Buffers get
 *
 * Parameters:
 *   file - file to get the object from
 **********************************************/
	public function pb_get($file)
	{
        $data = $this->path.'/fs/'.$this->user.'/Data/'.basename($file);
        if(is_file($data))
        {
            return file_get_contents($data);
        }
        return false;
	}
}
?>