<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.3
    Web 2.0 Operating System
*/
/**********************************************
 * File: syscall.php
 * Link between Javascript and PHP for System Requests
 **********************************************/
include('Server.class.php');
/**********************************************
 * Variables: Request
 * session_id - Session id got from the requester
 * req - request string
 * os - os object stored in session
 * type - type of the output file (html, gzip, javascript, css, etc)
 **********************************************/
$session_id = $_GET['session_id'] ? $_GET['session_id'] : 0;
$req = $_POST['req'] ? $_POST['req'] : ($_GET['req'] ? $_GET['req'] : '');
$os = os::getInstance($session_id);
$type='text/html';

switch($req)
{
	case 'restartKernel':
		$os->restartKernel();
		break;
	case 'logout':
		$os = $os->logout();
		break;
	case 'includeJs':
        $file = $os_path.$os->processPath($_GET['file']);
        $os->compressFile('text/javascript');
        require $file;
        //if(!strpos($file, 'mootools')) {
        //    echo $os->minifyFile($file);
        //}
        //else {
        //    require $file;
        //}
		break;
	case 'includeCss':
        $file = $os_path.$os->processPath($_GET['file']);
        $os->compressFile('text/css');
		echo $os->minifyFile($file);
		break;
    case 'connectionTest':
        $os->connectionTest($_GET['size']);
        break;
	case 'startProcess':
		$os->startProcess($_POST['id']);
		break;
	case 'killProcess':
		$os->killProcess($_POST['id']);
		break;
	case 'createDesktop':
        $os->compressFile($type);
        //Applications
        include($os_path.'/Kernel/Server/ProtocolBuffers.class.php');
        include($os_path.'/Kernel/Server/Programs.class.php');
        $pb = new Programs($os);
        $apps = $pb->pb_apps_get();
        if($os_distributed){
            $apps_path = $os->getColumn($apps['rows'], 2);
            $apps_path = $os->getFiles($apps_path);
            $apps['rows'] = $os->setColumn($apps['rows'], $apps_path, 2);
        }
        $request[] = array('apps', $apps);
        //Icons
		$dir = $os_path.$os->processPath('/fs/'.$os->user.'/Desktop');
		$dirs = $os->readDir($dir);
		$icons = $os->getIcons($dirs, $dir, 'desktop', 'desktop');
        $request[] = array('icons', $icons);
        // Display request
        echo $os->buildRequest($request);
		break;
	case 'buildModulesList':
        include('ProtocolBuffers.class.php');
        include('Programs.class.php');
        $pb = new Programs($os);
        $os->compressFile($type);
        $modules = $pb->buildModulesList();
        if($modules===true) {
            $msg = 'Modules list builded !';
            // Reload modules
            $apps = $pb->pb_apps_get();
            $request[] = array('apps', $apps);
        }
        else {
            $msg = $modules;
        }
        //Result message
        $request[] = array('window_info',
            array('Programs: List',
                array('content'=>$msg,
                'modal'=>false,
                'childOf'=>'programs')));
        //Request
        echo $os->buildRequest($request);
		break;
	// Nothing to do
	default:
		echo 'Why are you here ?';
}
?>