/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

             v. 1.3
        Web Operating System
*/
/**********************************************
 * Class: OS.taskbar
 **********************************************/ 
OS.taskbar = {
    'item': $('taskbar'),
    'nb': 0,
    /**********************************************
     * Method: add
     * Add an element to the taskbar (a window)
     **********************************************/
    'add': function(id, label)
    {        
        var link = new Element('div', {
            'id': id+'_reduced',
            'html': label,
            'events': {'click': function(){ OS.toggleWindow(id); }}
        });
        link.inject(this.item);
        
        //Offset calculation FIXME: refactor any time
        var width = link.offsetWidth;
        var height = link.offsetHeight;
        var TB = this.item.getStyles('margin-left', 'margin-right', 'padding-left', 'padding-right');
        var paddingTB = TB['padding-left'].toInt()+TB['padding-right'].toInt();
        var marginSys = OS.system.getStyles('margin-right')['margin-right'].toInt();
        var widthTB = OS.dw - TB['margin-left'].toInt() - TB['margin-right'].toInt() - (paddingTB + marginSys) -2;
        var heightTB = this.item.offsetHeight;
        var maxW = (widthTB / width).toInt();
        var maxH = (heightTB / height).toInt();
        if(maxH<1) {maxH=1};
        var max = maxW * maxH;
        this.nb +=1;
        if(this.nb > max)
        {
            var items = $$('#taskbar div');
            var even = (this.nb%2===0) ? 0 : 1;
            var maxPerLine = (this.nb / maxH).toInt() + even;
            var marginLink = link.getStyles('margin-right')['margin-right'].toInt();
            var widthNew = ((widthTB - marginLink*maxPerLine) / maxPerLine);
            items.each(function(item)
            {
                item.style.width = widthNew+'px';
            });
        }
    },
    
    /**********************************************
     * Method: rm
     * Remove an element from the taskbar
     * 
     * Parameters:
     *     id - identifiant of the window to remove
     **********************************************/
    'rm': function(id)
    {//TODO: re-calcul depassement
        var link = $(id+'_reduced');
        OS.taskbar.item.removeChild(link);
        this.nb -=1;
    },
    
    /**********************************************
     * Method: hide
     * Make the Element unavailable
     * 
     * Parameters:
     *     id - Window's Element id
     **********************************************/
    'hide': function(id){
        var link = $(id+'_reduced');
        if(link)
        {
            var hidden = link.getLast('.taskbar_hide');
            if(hidden)
            {
                hidden.dispose();
            }
            else
            {
                var hide = new Element('div',{
                    'class': 'taskbar_hide',
                    'events': {'click': function(e)
                    {
                        e.stopPropagation();
                    }}
                });
                link.store('hide', hide);
                hide.inject(link);
                OS.updateZindex('', hide);
                OS.updateZindex(id);
            }
        }
    }
};
