/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.3
    Web 2.0 Operating System
*/
/**********************************************
 * Class: perms
 * Permissions settings
 **********************************************/
OS.modules.init.push({
	'id': 'perms',
	'init': new Class({

'label': 'Permissions',
'childOf': 'admin',
'path': 'programs/admin/perms.php',

'start': function()
{
	OS.createWindow(this.label, this.id,
	{
		'width':   428,
		'height':  203,
        'minx': 375,
        'miny': 50,
        'onCreated': function()
        {
            var id = OS.modules.run.perms.id;
            var content = $(id+'_content');
           
           
           // Files Permissions
            var gui = new OS.gui({
                'type': 'fieldset',
                'label': 'Files',
                'className': 'perms_files'
            });
            gui.radio(id, 'light', 'Permissive');
            gui.radio(id, 'base', 'Base', {'checked': true});
            gui.radio(id, 'secure', 'Secure');
            gui.radio(id, 'custom', 'Custom : ');
            var selectCustom = function(){gui.radioSet('custom', id, content)};
            gui.field(id+'_0', {'label': 'scripts & index.php', 'maxlength': 4, 'focus': selectCustom});
            gui.field(id+'_1', {'label': 'kernel & programs', 'maxlength': 4, 'focus': selectCustom});
            gui.field(id+'_2', {'label': 'filesystem', 'maxlength': 4, 'focus': selectCustom});
            gui.button(id, 'Set permissions', {'action': function() {
                OS.modules.run.perms.setPerms(gui, t, content);
            }});
            gui.inject(content);
            
            
            // Users Permissions
            gui = new OS.gui({
                'type': 'fieldset',
                'label': 'Users',
                'className': 'perms_users'
            });
            gui.label(id, 'Groups:', {'forElem': id+'_groups_gui_option'});
            gui.option(id+'_groups', {
                'multiple': true,
                'options':[
                    ['Admin', 'admin'],
                    ['Default User', 'default']
                ]
            });
            gui.inject(content);
        }
	});
},

'setPerms': function(gui, t, content)
{
    var perm = gui.radioGet(t, content);
    if(perm!='custom')
    {
        OS.modules.run.perms.ask(perm);
    }
    else
    {
        var f0 = $(t+'_0_gui_field').value;
        var f1 = $(t+'_1_gui_field').value;
        var f2 = $(t+'_2_gui_field').value;
        if(f0 && f1 && f2)
        {
            OS.modules.run.perms.ask('custom', f0+','+f1+','+f2);
        }
        else
        {
            OS.infoWindow('Alert !', $time()+'_error', {
                'content': 'You must fill all fields !',
                'childOf': 'perms'
            });
        }
    }
},

'ask': function(type, value)
{
    value = value ? value : false;
    OS.infoWindow('Alert !', 'menu_CloseConfirm', {
        'content': 'Do you want to <strong>Set '+type.capitalize()+' Permissions</strong> ?',
        'childOf': 'perms',
        'actions': {
            'yes': function()
            {
                OS.sendRequest(OS.modules.run.perms.path, {
                    'post': 'req='+type+'&value='+value
                });
            },
            'no': {}
        }
    });
}

})});
