#!/bin/sh
# @author: Aubort Jean-Baptiste <aubort.jeanbaptiste@gmail.com> 06.01.2009
# Syncronise current version with its servers

BaseDir='/var/www/secure/takos-core'
ServerRoot='servers'
ServerDirs='demo1 demo2 demo3'

# Check if cURL is installed
curl --silent google.com>/dev/null
[ $? -ne 0 ] && echo 'Curl is not installed' && exit 1

# Visual progress
spinner(){
    PROC=$1
    start_time=`date +%s`
    while [ -d /proc/$PROC ];do
        echo -n '.' ; sleep 1
    done
    finish_time=`date +%s`
    echo "\nTime duration: $((finish_time - start_time)) secs."
    return 0
}

# Start
if [ -n "$1" ] && [ -n "$2" ] && [ -n "$3" ]; then
    cd $BaseDir
    Files=`echo $(find . -regex ".*\.\(js\|css\|png\|jpg\|gif\)$")`
    Arg=''
    for Dir in $ServerDirs; do
        for File in $Files; do
            Arg="$Arg -T $File ftp://$1/$ServerRoot/$Dir/$File"
        done
    done
    curl --silent --ftp-create-dirs -u $2:$3 $Arg & spinner $!
else
    echo "Usage: sh $0 ftp.server.com user password"
fi

